﻿// <auto-generated />
using System;
using Infrastructure.Persistence;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace AEWeb.Migrations
{
    [DbContext(typeof(ApplicationDbContext))]
    [Migration("20200610104259_v_1_6_0_FixAudit_TaxPayerStats")]
    partial class v_1_6_0_FixAudit_TaxPayerStats
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.4")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("Domain.AuditStats.AuditStats", b =>
                {
                    b.Property<int>("AuditDataID")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("auditDataID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<decimal?>("TotalAdditionalAssessment")
                        .HasColumnName("totalAdditionalAssessment")
                        .HasColumnType("money");

                    b.Property<string>("officeID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("regionID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("segmentID")
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("AuditDataID");

                    b.HasIndex("officeID");

                    b.HasIndex("regionID");

                    b.HasIndex("segmentID");

                    b.ToTable("AuditStats");
                });

            modelBuilder.Entity("Domain.CountryStats.CountryStats", b =>
                {
                    b.Property<int>("CountryStatsID")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("countryStatsID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<decimal?>("GdpPerCapitaAtDate")
                        .HasColumnName("gdpPerCapitaAtDate")
                        .HasColumnType("money");

                    b.Property<decimal?>("NominalGdpAtDate")
                        .HasColumnName("nominalGdpAtDate")
                        .HasColumnType("money");

                    b.HasKey("CountryStatsID");

                    b.ToTable("CountryStats");
                });

            modelBuilder.Entity("Domain.Dashboard.Dashboard", b =>
                {
                    b.Property<Guid>("DashboardId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier");

                    b.Property<string>("CreatorId")
                        .HasColumnType("nvarchar(450)");

                    b.Property<int>("Status")
                        .HasColumnType("int");

                    b.Property<int>("Type")
                        .HasColumnType("int");

                    b.HasKey("DashboardId");

                    b.HasIndex("CreatorId");

                    b.ToTable("Dashboards");
                });

            modelBuilder.Entity("Domain.Indicators.Kpi", b =>
                {
                    b.Property<Guid>("KpiId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier");

                    b.Property<byte[]>("TimeStamp")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnName("Timestamp")
                        .HasColumnType("rowversion");

                    b.Property<int>("Type")
                        .HasColumnType("int");

                    b.Property<int>("ViewType")
                        .HasColumnType("int");

                    b.HasKey("KpiId");

                    b.ToTable("Kpis");
                });

            modelBuilder.Entity("Domain.Office.Office", b =>
                {
                    b.Property<string>("officeID")
                        .HasColumnType("nvarchar(20)")
                        .HasMaxLength(20);

                    b.HasKey("officeID")
                        .HasName("officeID");

                    b.ToTable("Office");
                });

            modelBuilder.Entity("Domain.Region.Region", b =>
                {
                    b.Property<string>("regionID")
                        .HasColumnType("nvarchar(20)")
                        .HasMaxLength(20);

                    b.HasKey("regionID")
                        .HasName("regionID");

                    b.ToTable("Region");
                });

            modelBuilder.Entity("Domain.Region.RegionStats", b =>
                {
                    b.Property<int>("RegionStatsId")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("regionStatsID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<decimal?>("GdpPerCapitaAtDate")
                        .HasColumnName("gdpPerCapitaAtDate")
                        .HasColumnType("money");

                    b.Property<decimal?>("NominalGdpAtDate")
                        .HasColumnName("nominalGdpAtDate")
                        .HasColumnType("money");

                    b.Property<string>("regionID")
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("RegionStatsId");

                    b.HasIndex("regionID");

                    b.ToTable("RegionStats");
                });

            modelBuilder.Entity("Domain.Security.ApplicationUser", b =>
                {
                    b.Property<string>("Id")
                        .HasColumnType("nvarchar(450)");

                    b.Property<int>("AccessFailedCount")
                        .HasColumnType("int");

                    b.Property<bool>("Active")
                        .HasColumnType("bit");

                    b.Property<string>("ConcurrencyStamp")
                        .IsConcurrencyToken()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Email")
                        .HasColumnType("nvarchar(256)")
                        .HasMaxLength(256);

                    b.Property<bool>("EmailConfirmed")
                        .HasColumnType("bit");

                    b.Property<string>("FirstName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("LastName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("LockoutEnabled")
                        .HasColumnType("bit");

                    b.Property<DateTimeOffset?>("LockoutEnd")
                        .HasColumnType("datetimeoffset");

                    b.Property<string>("NormalizedEmail")
                        .HasColumnType("nvarchar(256)")
                        .HasMaxLength(256);

                    b.Property<string>("NormalizedUserName")
                        .HasColumnType("nvarchar(256)")
                        .HasMaxLength(256);

                    b.Property<string>("PasswordHash")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("PersonalExtension")
                        .HasColumnType("nvarchar(max)");

                    b.Property<long>("PersonalIdNumber")
                        .HasColumnType("bigint");

                    b.Property<string>("PhoneNumber")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("PhoneNumberConfirmed")
                        .HasColumnType("bit");

                    b.Property<string>("SecurityStamp")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("TwoFactorEnabled")
                        .HasColumnType("bit");

                    b.Property<string>("UserName")
                        .HasColumnType("nvarchar(256)")
                        .HasMaxLength(256);

                    b.HasKey("Id");

                    b.HasIndex("NormalizedEmail")
                        .HasName("EmailIndex");

                    b.HasIndex("NormalizedUserName")
                        .IsUnique()
                        .HasName("UserNameIndex")
                        .HasFilter("[NormalizedUserName] IS NOT NULL");

                    b.ToTable("AspNetUsers");
                });

            modelBuilder.Entity("Domain.Segment.Segment", b =>
                {
                    b.Property<string>("segmentID")
                        .HasColumnType("nvarchar(20)")
                        .HasMaxLength(20);

                    b.HasKey("segmentID")
                        .HasName("segmentID");

                    b.ToTable("Segment");
                });

            modelBuilder.Entity("Domain.Tax.Arrear", b =>
                {
                    b.Property<int>("ArrearItemID")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("arrearItemID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("officeID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("regionID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("segmentID")
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("ArrearItemID");

                    b.HasIndex("officeID");

                    b.HasIndex("regionID");

                    b.HasIndex("segmentID");

                    b.ToTable("Arrears");
                });

            modelBuilder.Entity("Domain.Tax.Import", b =>
                {
                    b.Property<int>("ImportID")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("ImportID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.HasKey("ImportID");

                    b.ToTable("Imports");
                });

            modelBuilder.Entity("Domain.Tax.Revenue", b =>
                {
                    b.Property<int>("RevenueItemID")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("revenueItemID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("officeID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("regionID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("segmentID")
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("RevenueItemID");

                    b.HasIndex("officeID");

                    b.HasIndex("regionID");

                    b.HasIndex("segmentID");

                    b.ToTable("Revenue");
                });

            modelBuilder.Entity("Domain.Tax.RevenueForecast", b =>
                {
                    b.Property<int>("ForecastItemID")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("forecastItemID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("officeID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("regionID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("segmentID")
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("ForecastItemID");

                    b.HasIndex("officeID");

                    b.HasIndex("regionID");

                    b.HasIndex("segmentID");

                    b.ToTable("RevenueForecast");
                });

            modelBuilder.Entity("Domain.Tax.RevenueSummaryByMonth", b =>
                {
                    b.Property<int>("RevenueSummaryID")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("revenueSummaryID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("officeID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("regionID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("segmentID")
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("RevenueSummaryID");

                    b.HasIndex("officeID");

                    b.HasIndex("regionID");

                    b.HasIndex("segmentID");

                    b.ToTable("RevenueSummaryByMonth");
                });

            modelBuilder.Entity("Domain.Tax.TaxPayerStats", b =>
                {
                    b.Property<int>("TaxPayerStatsID")
                        .ValueGeneratedOnAdd()
                        .HasColumnName("taxPayerStatsID")
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("officeID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("regionID")
                        .HasColumnType("nvarchar(20)");

                    b.Property<string>("segmentID")
                        .HasColumnType("nvarchar(20)");

                    b.HasKey("TaxPayerStatsID");

                    b.HasIndex("officeID");

                    b.HasIndex("regionID");

                    b.HasIndex("segmentID");

                    b.ToTable("TaxPayerStats");
                });

            modelBuilder.Entity("Domain.Tax.TaxRate", b =>
                {
                    b.Property<int>("TaxRateId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<decimal>("Rate")
                        .HasColumnName("taxRate")
                        .HasColumnType("decimal(18,3)");

                    b.HasKey("TaxRateId")
                        .HasName("taxRateID");

                    b.ToTable("TaxRates");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRole", b =>
                {
                    b.Property<string>("Id")
                        .HasColumnType("nvarchar(450)");

                    b.Property<string>("ConcurrencyStamp")
                        .IsConcurrencyToken()
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(256)")
                        .HasMaxLength(256);

                    b.Property<string>("NormalizedName")
                        .HasColumnType("nvarchar(256)")
                        .HasMaxLength(256);

                    b.HasKey("Id");

                    b.HasIndex("NormalizedName")
                        .IsUnique()
                        .HasName("RoleNameIndex")
                        .HasFilter("[NormalizedName] IS NOT NULL");

                    b.ToTable("AspNetRoles");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRoleClaim<string>", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("ClaimType")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("ClaimValue")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("RoleId")
                        .IsRequired()
                        .HasColumnType("nvarchar(450)");

                    b.HasKey("Id");

                    b.HasIndex("RoleId");

                    b.ToTable("AspNetRoleClaims");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserClaim<string>", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("ClaimType")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("ClaimValue")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("UserId")
                        .IsRequired()
                        .HasColumnType("nvarchar(450)");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("AspNetUserClaims");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserLogin<string>", b =>
                {
                    b.Property<string>("LoginProvider")
                        .HasColumnType("nvarchar(450)");

                    b.Property<string>("ProviderKey")
                        .HasColumnType("nvarchar(450)");

                    b.Property<string>("ProviderDisplayName")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("UserId")
                        .IsRequired()
                        .HasColumnType("nvarchar(450)");

                    b.HasKey("LoginProvider", "ProviderKey");

                    b.HasIndex("UserId");

                    b.ToTable("AspNetUserLogins");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserRole<string>", b =>
                {
                    b.Property<string>("UserId")
                        .HasColumnType("nvarchar(450)");

                    b.Property<string>("RoleId")
                        .HasColumnType("nvarchar(450)");

                    b.HasKey("UserId", "RoleId");

                    b.HasIndex("RoleId");

                    b.ToTable("AspNetUserRoles");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserToken<string>", b =>
                {
                    b.Property<string>("UserId")
                        .HasColumnType("nvarchar(450)");

                    b.Property<string>("LoginProvider")
                        .HasColumnType("nvarchar(450)");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(450)");

                    b.Property<string>("Value")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("UserId", "LoginProvider", "Name");

                    b.ToTable("AspNetUserTokens");
                });

            modelBuilder.Entity("Domain.AuditStats.AuditStats", b =>
                {
                    b.HasOne("Domain.Office.Office", "OfficeID")
                        .WithMany()
                        .HasForeignKey("officeID");

                    b.HasOne("Domain.Region.Region", "RegionID")
                        .WithMany()
                        .HasForeignKey("regionID");

                    b.HasOne("Domain.Segment.Segment", "SegmentID")
                        .WithMany()
                        .HasForeignKey("segmentID");

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "NumberOfAuditsPerformed", b1 =>
                        {
                            b1.Property<int>("AuditStatsAuditDataID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("numberOfAuditsPerformed")
                                .HasColumnType("int");

                            b1.HasKey("AuditStatsAuditDataID");

                            b1.ToTable("AuditStats");

                            b1.WithOwner()
                                .HasForeignKey("AuditStatsAuditDataID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "NumberOfAuditsResultedInAdditionalAssessments", b1 =>
                        {
                            b1.Property<int>("AuditStatsAuditDataID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("numberOfAuditsResultedInAdditionalAssessments")
                                .HasColumnType("int");

                            b1.HasKey("AuditStatsAuditDataID");

                            b1.ToTable("AuditStats");

                            b1.WithOwner()
                                .HasForeignKey("AuditStatsAuditDataID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "StatsDate", b1 =>
                        {
                            b1.Property<int?>("AuditStatsTempId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("statsDate")
                                .HasColumnType("date");

                            b1.HasKey("AuditStatsTempId");

                            b1.ToTable("AuditStats");

                            b1.WithOwner()
                                .HasForeignKey("AuditStatsTempId");
                        });
                });

            modelBuilder.Entity("Domain.CountryStats.CountryStats", b =>
                {
                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "StatsDate", b1 =>
                        {
                            b1.Property<int>("CountryStatsID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("statsDate")
                                .HasColumnType("date");

                            b1.HasKey("CountryStatsID");

                            b1.ToTable("CountryStats");

                            b1.WithOwner()
                                .HasForeignKey("CountryStatsID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "PopulationAtDate", b1 =>
                        {
                            b1.Property<int>("CountryStatsID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("populationAtDate")
                                .HasColumnType("int");

                            b1.HasKey("CountryStatsID");

                            b1.ToTable("CountryStats");

                            b1.WithOwner()
                                .HasForeignKey("CountryStatsID");
                        });
                });

            modelBuilder.Entity("Domain.Dashboard.Dashboard", b =>
                {
                    b.HasOne("Domain.Security.ApplicationUser", "Creator")
                        .WithMany()
                        .HasForeignKey("CreatorId");

                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "Name", b1 =>
                        {
                            b1.Property<Guid>("DashboardId")
                                .HasColumnType("uniqueidentifier");

                            b1.Property<string>("Value")
                                .HasColumnName("Name")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("DashboardId");

                            b1.ToTable("Dashboards");

                            b1.WithOwner()
                                .HasForeignKey("DashboardId");
                        });
                });

            modelBuilder.Entity("Domain.Indicators.Kpi", b =>
                {
                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "Title", b1 =>
                        {
                            b1.Property<Guid>("KpiId")
                                .HasColumnType("uniqueidentifier");

                            b1.Property<string>("Value")
                                .HasColumnName("Title")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("KpiId");

                            b1.ToTable("Kpis");

                            b1.WithOwner()
                                .HasForeignKey("KpiId");
                        });
                });

            modelBuilder.Entity("Domain.Office.Office", b =>
                {
                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "officeName", b1 =>
                        {
                            b1.Property<string>("officeID")
                                .HasColumnType("nvarchar(20)");

                            b1.Property<string>("Value")
                                .HasColumnName("officeName")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("officeID");

                            b1.ToTable("Office");

                            b1.WithOwner()
                                .HasForeignKey("officeID");
                        });
                });

            modelBuilder.Entity("Domain.Region.Region", b =>
                {
                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "regionName", b1 =>
                        {
                            b1.Property<string>("regionID")
                                .HasColumnType("nvarchar(20)");

                            b1.Property<string>("Value")
                                .HasColumnName("regionName")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("regionID");

                            b1.ToTable("Region");

                            b1.WithOwner()
                                .HasForeignKey("regionID");
                        });
                });

            modelBuilder.Entity("Domain.Region.RegionStats", b =>
                {
                    b.HasOne("Domain.Region.Region", "RegionID")
                        .WithMany()
                        .HasForeignKey("regionID");

                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "StatsDate", b1 =>
                        {
                            b1.Property<int>("RegionStatsId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("statsDate")
                                .HasColumnType("date");

                            b1.HasKey("RegionStatsId");

                            b1.ToTable("RegionStats");

                            b1.WithOwner()
                                .HasForeignKey("RegionStatsId");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "PopulationAtDate", b1 =>
                        {
                            b1.Property<int>("RegionStatsId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("populationAtDate")
                                .HasColumnType("int");

                            b1.HasKey("RegionStatsId");

                            b1.ToTable("RegionStats");

                            b1.WithOwner()
                                .HasForeignKey("RegionStatsId");
                        });
                });

            modelBuilder.Entity("Domain.Segment.Segment", b =>
                {
                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "segmentName", b1 =>
                        {
                            b1.Property<string>("segmentID")
                                .HasColumnType("nvarchar(20)");

                            b1.Property<string>("Value")
                                .HasColumnName("segmentName")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("segmentID");

                            b1.ToTable("Segment");

                            b1.WithOwner()
                                .HasForeignKey("segmentID");
                        });
                });

            modelBuilder.Entity("Domain.Tax.Arrear", b =>
                {
                    b.HasOne("Domain.Office.Office", "OfficeID")
                        .WithMany()
                        .HasForeignKey("officeID");

                    b.HasOne("Domain.Region.Region", "RegionID")
                        .WithMany()
                        .HasForeignKey("regionID");

                    b.HasOne("Domain.Segment.Segment", "SegmentID")
                        .WithMany()
                        .HasForeignKey("segmentID");

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "Amount", b1 =>
                        {
                            b1.Property<int>("ArrearItemID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("amount")
                                .HasColumnType("money");

                            b1.HasKey("ArrearItemID");

                            b1.ToTable("Arrears");

                            b1.WithOwner()
                                .HasForeignKey("ArrearItemID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "Concept", b1 =>
                        {
                            b1.Property<int?>("ArrearTempId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<string>("Value")
                                .HasColumnName("concept")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("ArrearTempId");

                            b1.ToTable("Arrears");

                            b1.WithOwner()
                                .HasForeignKey("ArrearTempId");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "ConceptID", b1 =>
                        {
                            b1.Property<int?>("ArrearTempId1")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<string>("Value")
                                .HasColumnName("conceptID")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("ArrearTempId1");

                            b1.ToTable("Arrears");

                            b1.WithOwner()
                                .HasForeignKey("ArrearTempId1");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "ArrearDate", b1 =>
                        {
                            b1.Property<int?>("ArrearTempId2")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("arrearDate")
                                .HasColumnType("date");

                            b1.HasKey("ArrearTempId2");

                            b1.ToTable("Arrears");

                            b1.WithOwner()
                                .HasForeignKey("ArrearTempId2");
                        });
                });

            modelBuilder.Entity("Domain.Tax.Import", b =>
                {
                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "ImportDate", b1 =>
                        {
                            b1.Property<int>("ImportID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("importDate")
                                .HasColumnType("date");

                            b1.HasKey("ImportID");

                            b1.ToTable("Imports");

                            b1.WithOwner()
                                .HasForeignKey("ImportID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalImports", b1 =>
                        {
                            b1.Property<int>("ImportID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalImports")
                                .HasColumnType("money");

                            b1.HasKey("ImportID");

                            b1.ToTable("Imports");

                            b1.WithOwner()
                                .HasForeignKey("ImportID");
                        });
                });

            modelBuilder.Entity("Domain.Tax.Revenue", b =>
                {
                    b.HasOne("Domain.Office.Office", "OfficeID")
                        .WithMany()
                        .HasForeignKey("officeID");

                    b.HasOne("Domain.Region.Region", "RegionID")
                        .WithMany()
                        .HasForeignKey("regionID");

                    b.HasOne("Domain.Segment.Segment", "SegmentID")
                        .WithMany()
                        .HasForeignKey("segmentID");

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "Amount", b1 =>
                        {
                            b1.Property<int>("RevenueItemID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("amount")
                                .HasColumnType("money");

                            b1.HasKey("RevenueItemID");

                            b1.ToTable("Revenue");

                            b1.WithOwner()
                                .HasForeignKey("RevenueItemID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "Concept", b1 =>
                        {
                            b1.Property<int?>("RevenueTempId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<string>("Value")
                                .HasColumnName("concept")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("RevenueTempId");

                            b1.ToTable("Revenue");

                            b1.WithOwner()
                                .HasForeignKey("RevenueTempId");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "ConceptID", b1 =>
                        {
                            b1.Property<int?>("RevenueTempId1")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<string>("Value")
                                .HasColumnName("conceptID")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("RevenueTempId1");

                            b1.ToTable("Revenue");

                            b1.WithOwner()
                                .HasForeignKey("RevenueTempId1");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "RevenueDate", b1 =>
                        {
                            b1.Property<int?>("RevenueTempId2")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("revenueDate")
                                .HasColumnType("date");

                            b1.HasKey("RevenueTempId2");

                            b1.ToTable("Revenue");

                            b1.WithOwner()
                                .HasForeignKey("RevenueTempId2");
                        });
                });

            modelBuilder.Entity("Domain.Tax.RevenueForecast", b =>
                {
                    b.HasOne("Domain.Office.Office", "OfficeID")
                        .WithMany()
                        .HasForeignKey("officeID");

                    b.HasOne("Domain.Region.Region", "RegionID")
                        .WithMany()
                        .HasForeignKey("regionID");

                    b.HasOne("Domain.Segment.Segment", "SegmentID")
                        .WithMany()
                        .HasForeignKey("segmentID");

                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "ForecastDate", b1 =>
                        {
                            b1.Property<int>("RevenueForecastForecastItemID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("forecastDate")
                                .HasColumnType("date");

                            b1.HasKey("RevenueForecastForecastItemID");

                            b1.ToTable("RevenueForecast");

                            b1.WithOwner()
                                .HasForeignKey("RevenueForecastForecastItemID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "Amount", b1 =>
                        {
                            b1.Property<int>("RevenueForecastForecastItemID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("amount")
                                .HasColumnType("money");

                            b1.HasKey("RevenueForecastForecastItemID");

                            b1.ToTable("RevenueForecast");

                            b1.WithOwner()
                                .HasForeignKey("RevenueForecastForecastItemID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "Concept", b1 =>
                        {
                            b1.Property<int?>("RevenueForecastTempId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<string>("Value")
                                .HasColumnName("concept")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("RevenueForecastTempId");

                            b1.ToTable("RevenueForecast");

                            b1.WithOwner()
                                .HasForeignKey("RevenueForecastTempId");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "ConceptID", b1 =>
                        {
                            b1.Property<int?>("RevenueForecastTempId1")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<string>("Value")
                                .HasColumnName("conceptID")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("RevenueForecastTempId1");

                            b1.ToTable("RevenueForecast");

                            b1.WithOwner()
                                .HasForeignKey("RevenueForecastTempId1");
                        });
                });

            modelBuilder.Entity("Domain.Tax.RevenueSummaryByMonth", b =>
                {
                    b.HasOne("Domain.Office.Office", "OfficeID")
                        .WithMany()
                        .HasForeignKey("officeID");

                    b.HasOne("Domain.Region.Region", "RegionID")
                        .WithMany()
                        .HasForeignKey("regionID");

                    b.HasOne("Domain.Segment.Segment", "SegmentID")
                        .WithMany()
                        .HasForeignKey("segmentID");

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenue", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenue")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenueFromArrears", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenueFromArrears")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenueFromAudits", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenueFromAudits")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenueFromEnforcementCollection", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenueFromEnforcementCollection")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenueFromFines", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenueFromFines")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenueFromLitigation", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenueFromLitigation")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenueFromTaxes", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenueFromTaxes")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenueFromVoluntaryCompliance", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenueFromVoluntaryCompliance")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveDecimal", "TotalRevenuePaidInTIme", b1 =>
                        {
                            b1.Property<int>("RevenueSummaryByMonthRevenueSummaryID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<decimal>("Value")
                                .HasColumnName("totalRevenuePaidInTIme")
                                .HasColumnType("money");

                            b1.HasKey("RevenueSummaryByMonthRevenueSummaryID");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthRevenueSummaryID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "RevenueDate", b1 =>
                        {
                            b1.Property<int?>("RevenueSummaryByMonthTempId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("revenueDate")
                                .HasColumnType("date");

                            b1.HasKey("RevenueSummaryByMonthTempId");

                            b1.ToTable("RevenueSummaryByMonth");

                            b1.WithOwner()
                                .HasForeignKey("RevenueSummaryByMonthTempId");
                        });
                });

            modelBuilder.Entity("Domain.Tax.TaxPayerStats", b =>
                {
                    b.HasOne("Domain.Office.Office", "OfficeID")
                        .WithMany()
                        .HasForeignKey("officeID");

                    b.HasOne("Domain.Region.Region", "RegionID")
                        .WithMany()
                        .HasForeignKey("regionID");

                    b.HasOne("Domain.Segment.Segment", "SegmentID")
                        .WithMany()
                        .HasForeignKey("segmentID");

                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "StatsDate", b1 =>
                        {
                            b1.Property<int>("TaxPayerStatsID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("statsDate")
                                .HasColumnType("date");

                            b1.HasKey("TaxPayerStatsID");

                            b1.ToTable("TaxPayerStats");

                            b1.WithOwner()
                                .HasForeignKey("TaxPayerStatsID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "NumberOfActiveTaxPayers", b1 =>
                        {
                            b1.Property<int>("TaxPayerStatsID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("numberOfActiveTaxPayers")
                                .HasColumnType("int");

                            b1.HasKey("TaxPayerStatsID");

                            b1.ToTable("TaxPayerStats");

                            b1.WithOwner()
                                .HasForeignKey("TaxPayerStatsID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "NumberOfRegisteredTaxPayers", b1 =>
                        {
                            b1.Property<int>("TaxPayerStatsID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("numberOfRegisteredTaxPayers")
                                .HasColumnType("int");

                            b1.HasKey("TaxPayerStatsID");

                            b1.ToTable("TaxPayerStats");

                            b1.WithOwner()
                                .HasForeignKey("TaxPayerStatsID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "NumberOfTaxPayers70PercentRevenue", b1 =>
                        {
                            b1.Property<int>("TaxPayerStatsID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("numberOfTaxPayers70PercentRevenue")
                                .HasColumnType("int");

                            b1.HasKey("TaxPayerStatsID");

                            b1.ToTable("TaxPayerStats");

                            b1.WithOwner()
                                .HasForeignKey("TaxPayerStatsID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "NumberOfTaxPayersFiled", b1 =>
                        {
                            b1.Property<int>("TaxPayerStatsID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("numberOfTaxPayersFiled")
                                .HasColumnType("int");

                            b1.HasKey("TaxPayerStatsID");

                            b1.ToTable("TaxPayerStats");

                            b1.WithOwner()
                                .HasForeignKey("TaxPayerStatsID");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.PositiveInteger", "NumberTaxPayersFiledInTime", b1 =>
                        {
                            b1.Property<int>("TaxPayerStatsID")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<int>("Value")
                                .HasColumnName("numberTaxPayersFiledInTime")
                                .HasColumnType("int");

                            b1.HasKey("TaxPayerStatsID");

                            b1.ToTable("TaxPayerStats");

                            b1.WithOwner()
                                .HasForeignKey("TaxPayerStatsID");
                        });
                });

            modelBuilder.Entity("Domain.Tax.TaxRate", b =>
                {
                    b.OwnsOne("Domain.ValueObjects.Shared.DateType", "TaxRateDate", b1 =>
                        {
                            b1.Property<int>("TaxRateId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<DateTime>("Value")
                                .HasColumnName("taxRateDate")
                                .HasColumnType("date");

                            b1.HasKey("TaxRateId");

                            b1.ToTable("TaxRates");

                            b1.WithOwner()
                                .HasForeignKey("TaxRateId");
                        });

                    b.OwnsOne("Domain.ValueObjects.Shared.Name250", "TaxName", b1 =>
                        {
                            b1.Property<int>("TaxRateId")
                                .ValueGeneratedOnAdd()
                                .HasColumnType("int")
                                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                            b1.Property<string>("Value")
                                .HasColumnName("taxName")
                                .HasColumnType("nvarchar(250)")
                                .HasMaxLength(250);

                            b1.HasKey("TaxRateId");

                            b1.ToTable("TaxRates");

                            b1.WithOwner()
                                .HasForeignKey("TaxRateId");
                        });
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRoleClaim<string>", b =>
                {
                    b.HasOne("Microsoft.AspNetCore.Identity.IdentityRole", null)
                        .WithMany()
                        .HasForeignKey("RoleId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserClaim<string>", b =>
                {
                    b.HasOne("Domain.Security.ApplicationUser", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserLogin<string>", b =>
                {
                    b.HasOne("Domain.Security.ApplicationUser", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserRole<string>", b =>
                {
                    b.HasOne("Microsoft.AspNetCore.Identity.IdentityRole", null)
                        .WithMany()
                        .HasForeignKey("RoleId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Domain.Security.ApplicationUser", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserToken<string>", b =>
                {
                    b.HasOne("Domain.Security.ApplicationUser", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
